SeedRnd MilliSecs()

Global ts=3200
Global Tweak_Perc#=0.5
Global Tweak_Strength#=0.5

Global Dither_Strength=2

Global Tweak_Smoothing=1

Global Tweak_Min=4
Global Tweak_Max=8

Global Tweak_Amount=2048

Global Texture_Zoom#=8

Global Set_Shape=0

Global Build_Images=10

If FileType("Output_Raw")=0 Then CreateDir("Output_Raw")
If FileType("Output_Raw_Tiled")=0 Then CreateDir("Output_Raw_Tiled")
If FileType("Output_Webbed")=0 Then CreateDir("Output_Webbed")
If FileType("Output_Webbed_Tiled")=0 Then CreateDir("Output_Webbed_Tiled")


If FileType("settings.ini")=1
quicky=ReadFile("settings.ini")
Repeat
	in$=ReadLine(quicky)
	cmd$=SplitText(in$,"=",1)
	parm$=SplitText(in$,"=",2)
	
	If cmd<>"-+-" And parm$<>"-+-" And Left$(cmd$,1)<>"#"
		If Lower$(cmd)="output size" Then ts=Abs(Int(parm$))
		If Lower$(cmd)="build images" Then Build_Images=Abs(Int(parm$))
		
		If Lower$(cmd)="maximum warp" Then Tweak_Perc=parm$
		If Lower$(cmd)="warp strength" Then Tweak_Strength=parm$
		
		If Lower$(cmd)="warp size"
			If Instr(parm$,",")>0
				Tweak_Min=SplitText$(parm$,",",1)
				Tweak_Max=SplitText$(parm$,",",2)
			EndIf
			If Instr(parm$,",")<1
				Tweak_Min=parm$
				Tweak_Max=Tweak_Min
			EndIf
		EndIf

		If Lower$(cmd)="warp amount" Then Tweak_Amount=Int(parm$)
		If Lower$(cmd)="warp dither"
			If Lower$(parm$)="high" Then Dither_Strength=3
			If Lower$(parm$)="medium" Then Dither_Strength=2
			If Lower$(parm$)="normal" Then Dither_Strength=2
			If Lower$(parm$)="low" Then Dither_Strength=1
			If Lower$(parm$)="none" Then Dither_Strength=0
		EndIf
		If Lower$(cmd)="warp smoothing"
			If Lower$(parm$)="off" Then Tweak_Smoothing=0
		EndIf
		
		If Lower$(cmd)="shape"
			If Lower$(parm$)="triangle" Then Set_Shape=1
			If Lower$(parm$)="rectangle" Then Set_Shape=2
			If Lower$(parm$)="square" Then Set_Shape=2
			
			If Lower$(parm$)="hexagon" Then Set_Shape=3
			If Lower$(parm$)="octagon" Then Set_Shape=4
		EndIf

	EndIf
	
Until Eof(quicky)
CloseFile quicky
EndIf


Graphics 640,640,0,2
Graphics ts,ts,0,3


Global Grip=CreateImage(ts,ts)
Global Loop=CreateImage(ts*2,ts*2)


SetBuffer BackBuffer()

Global Poly#[1024]
Global PolySides=0

Global Layout#[28000000]

Global gw#,gh#,gx,gy

Global Generated=0
n=KeyHit(1)

Repeat
fin=0
Generated=Generated+1

Width=Rand(1,4)
Size#=2^Rand(3,6)
If Size<20 And Width>2 Then Width=2

br=Rand(0,5)*50
bg=Rand(0,5)*50
bb=Rand(0,5)*50

;Width=1
;Size=32
;br=0:bg=0:bb=0

gw#=ts/size
gh#=ts/size



r=Rand(1,4)
If Set_Shape>0 Then r=Set_Shape
Select r
	Case 1 UsePoly(-1,-1,0,1,1,-1)
	Case 2 UsePoly(-1,-1,1,-1,1,1,-1,1)
	Case 3 UsePoly(-0.5,-1,0.5,-1,1,0,0.5,1,-0.5,1,-1,0)
	Case 4 UsePoly(-0.5,-1,0.5,-1,1,-0.5,1,0.5,0.5,1,-0.5,1,-1,0.5,-1,-0.5)
End Select

Warp()

ClsColor br,bg,bb
Cls

For x=-1 To gw
For y=-1 To gh

	warpx=x Mod gw
	If warpx<0 Then warpx=warpx+gw
	warpy=y Mod gh
	If warpy<0 Then warpy=warpy+gh

	r=(br*0.7)+(Layout[(((warpy*512)+warpx)*10)+1]*80)
	g=(bg*0.7)-(Layout[(((warpy*512)+warpx)*10)+1]*80)
	b=(bb*0.7)+(Layout[(((warpy*512)+warpx)*10)+2]*80)
	
	If r<0 Then r=0
	If r>255 Then r=255
	If g<0 Then g=0
	If g>255 Then g=255
	If b<0 Then b=0
	If b>255 Then b=255
	
	Color r,g,b
	Rect(((x-1)*size),((y-1)*size),size,size,1)
Next
If x Mod 25=0 Then Flip:Flip
Next

SaveBuffer BackBuffer(),"Output_Raw/"+Right$("0000"+Generated,4)+".bmp"

GrabImage(Grip,0,0)
SetBuffer ImageBuffer(Loop)
Cls
DrawImage(grip,0,0)
DrawImage(grip,0,ts)
DrawImage(grip,ts,0)
DrawImage(grip,ts,ts)
SaveBuffer ImageBuffer(Loop),"Output_Raw_Tiled/"+Right$("0000"+Generated,4)+".bmp"
SetBuffer BackBuffer()


Flip
Flip

fr=0
fg=0
fb=0
If br<150 And bg<150 And bb<150 Then fr=255:fg=255:fb=255

contrast=Rand(3,8)*10
r=Rand(1,4)
If r=1
	fr=br-contrast
	fg=bg-contrast
	fb=bb-contrast
EndIf
If r=2
	fr=br+contrast
	fg=bg+contrast
	fb=bb+contrast
EndIf


If fr<0 Then fr=0
If fr>255 Then fr=255
If fg<0 Then fg=0
If fg>255 Then fg=255
If fb<0 Then fb=0
If fb>255 Then fb=255




DebugLog gw+":"+gh
Color(fr,fg,fb)
For x=-1 To gw
For y=-1 To gh
	For w=0 To Width-1
		For m=1 To PolySides
			u=m+1
			If u>PolySides Then u=u-PolySides
			x1#=(x*size)+(Poly[(m*10)+1]*size)
			y1#=(y*size)+(Poly[(m*10)+2]*size)
			x2#=(x*size)+(Poly[(u*10)+1]*size)
			y2#=(y*size)+(Poly[(u*10)+2]*size)
			
			ex=x
;			If Poly[(m*10)+1]<0.25 Then ex=x-1
			If Poly[(m*10)+1]>0.25 Then ex=x+1
			
			ey=y
;			If Poly[(m*10)+2]<0.25 Then ey=y-1
			If Poly[(m*10)+2]>0.25 Then ey=y+1

			warpx=ex Mod gw
			If warpx<0 Then warpx=warpx+gw
			warpy=ey Mod gh
			If warpy<0 Then warpy=warpy+gh
			
			x1=x1+Layout[(((warpy*512)+warpx)*10)+1]*size
			y1=y1+Layout[(((warpy*512)+warpx)*10)+2]*size
			

			ex=x
;			If Poly[(u*10)+1]<0.25 Then ex=x-1
			If Poly[(u*10)+1]>0.25 Then ex=x+1
			
			ey=y
;			If Poly[(u*10)+2]<0.25 Then ey=y-1
			If Poly[(u*10)+2]>0.25 Then ey=y+1


			warpx=ex Mod gw
			If warpx<0 Then warpx=warpx+gw
			warpy=ey Mod gh
			If warpy<0 Then warpy=warpy+gh
			
			x2=x2+Layout[(((warpy*512)+warpx)*10)+1]*size
			y2=y2+Layout[(((warpy*512)+warpx)*10)+2]*size
			
			
			Line x1+w,y1,x2+w,y2
			Line x1,y1+w,x2,y2+w
		Next
	Next

Next
If x Mod 25=0 Then Flip:Flip
Next


Flip
Delay 25


Flip
SaveBuffer BackBuffer(),"Output_Webbed/"+Right$("0000"+Generated,4)+".bmp"

GrabImage(Grip,0,0)
SetBuffer ImageBuffer(Loop)
Cls
DrawImage(grip,0,0)
DrawImage(grip,0,ts)
DrawImage(grip,ts,0)
DrawImage(grip,ts,ts)
SaveBuffer ImageBuffer(Loop),"Output_Webbed_Tiled/"+Right$("0000"+Generated,4)+".bmp"
SetBuffer BackBuffer()


Flip
If Generated=>Build_Images Then fin=1

If KeyHit(1) Then fin=1
Until fin=1
End

Function UsePoly(x1#=-7,y1#=-7,x2#=-7,y2#=-7,x3#=-7,y3#=-7,x4#=-7,y4#=-7,x5#=-7,y5#=-7,x6#=-7,y6#=-7,x7#=-7,y7#=-7,x8#=-7,y8#=-7,x9#=-7,y9#=-7,x10#=-7,y10#=-7,x11#=-7,y11#=-7,x12#=-7,y12#=-7,x13#=-7,y13#=-7,x14#=-7,y14#=-7,x15#=-7,y15#=-7,x16#=-7,y16#=-7)

If x1>-7 Then Poly[(1*10)+1]=x1:PolySides=1
If y1>-7 Then Poly[(1*10)+2]=y1

If x2>-7 Then Poly[(2*10)+1]=x2:PolySides=2
If y2>-7 Then Poly[(2*10)+2]=y2

If x3>-7 Then Poly[(3*10)+1]=x3:PolySides=3
If y3>-7 Then Poly[(3*10)+2]=y3

If x4>-7 Then Poly[(4*10)+1]=x4:PolySides=4
If y4>-7 Then Poly[(4*10)+2]=y4

If x5>-7 Then Poly[(5*10)+1]=x5:PolySides=5
If y5>-7 Then Poly[(5*10)+2]=y5

If x6>-7 Then Poly[(6*10)+1]=x6:PolySides=6
If y6>-7 Then Poly[(6*10)+2]=y6

If x7>-7 Then Poly[(7*10)+1]=x7:PolySides=7
If y7>-7 Then Poly[(7*10)+2]=y7

If x8>-7 Then Poly[(8*10)+1]=x8:PolySides=8
If y8>-7 Then Poly[(8*10)+2]=y8

If x9>-7 Then Poly[(9*10)+1]=x9:PolySides=9
If y9>-7 Then Poly[(9*10)+2]=y9

If x10>-7 Then Poly[(10*10)+1]=x10:PolySides=10
If y10>-7 Then Poly[(10*10)+2]=y10

If x11>-7 Then Poly[(11*10)+1]=x11:PolySides=11
If y11>-7 Then Poly[(11*10)+2]=y11

If x12>-7 Then Poly[(12*10)+1]=x12:PolySides=12
If y12>-7 Then Poly[(12*10)+2]=y12

If x13>-7 Then Poly[(13*10)+1]=x13:PolySides=13
If y13>-7 Then Poly[(13*10)+2]=y13

If x14>-7 Then Poly[(14*10)+1]=x14:PolySides=14
If y14>-7 Then Poly[(14*10)+2]=y14

If x15>-7 Then Poly[(15*10)+1]=x15:PolySides=15
If y15>-7 Then Poly[(15*10)+2]=y15

If x16>-7 Then Poly[(16*10)+1]=x16:PolySides=16
If y16>-7 Then Poly[(16*10)+2]=y16

For n=1 To 16
	Poly[(n*10)+1]=Poly[(n*10)+1]/2
	Poly[(n*10)+2]=Poly[(n*10)+2]/2
	
Next


End Function


Function Warp()
gx=gw+2
gy=gh+2

For x=0 To gx-1
For y=0 To gy-1
	Layout[(((y*512)+x)*10)+1]=0
	Layout[(((y*512)+x)*10)+2]=0
	
	Layout[(((y*512)+x)*10)+3]=1+4
Next
Next

For n=1 To Tweak_Amount
	x=Rand(0,gx-1)
	y=Rand(0,gy-1)
	
	ar=Rand(Tweak_Min,Tweak_Max)
	Pull(x,y,ar,Rnd(-Tweak_Strength,Tweak_Strength),Rnd(-Tweak_Strength,Tweak_Strength))
Next


End Function


Function Pull(cx,cy,radius,pullx#,pully#)
Local x,y
gx=gw+2
gy=gh+2



For ex=cx-radius To cx+radius
For ey=cy-radius To cy+radius

full#=1
If Tweak_Smoothing=1
	distx#=Abs((cx-ex)*(cx-ex))
	disty#=Abs((cy-ey)*(cy-ey))
	dist#=Sqr(distx+disty)
	full#=(Float(Float(Radius)-Dist)/Float(Radius/2))
	If full>1 Then full=1
	If full<0 Then full=0
EndIf

	x=(ex Mod (gx-2))
	If x<0 Then x=gx+x
	x=x+1
	y=(ey Mod (gy-2))
	If y<0 Then y=gy+y
	y=y+1

r=8
If Dither_Strength=0 Then r=0
If Dither_Strength=1 Then r=6
If Dither_Strength=3 Then r=6

upx#=pullx
upy#=pully
If Dither_Strength=3
	upx#=Rnd(0,pullx)
		If pullx<0 Then upx=0-Abs(upx)
	upy#=Rnd(0,pully)
		If pully<0 Then upy=0-Abs(upy)
EndIf

upx=upx*full
upy=upy*full


	If Rand(0,r)<5 Then Layout[(((y*512)+x)*10)+1]=Layout[(((y*512)+x)*10)+1]+upx
	If Rand(0,r)<5 Then Layout[(((y*512)+x)*10)+2]=Layout[(((y*512)+x)*10)+2]+upy
	
	If Layout[(((y*512)+x)*10)+1]<0-Tweak_Perc Then Layout[(((y*512)+x)*10)+1]=0-Tweak_Perc
	If Layout[(((y*512)+x)*10)+2]<0-Tweak_Perc Then Layout[(((y*512)+x)*10)+2]=0-Tweak_Perc

	If Layout[(((y*512)+x)*10)+1]>Tweak_Perc Then Layout[(((y*512)+x)*10)+1]=Tweak_Perc
	If Layout[(((y*512)+x)*10)+2]>Tweak_Perc Then Layout[(((y*512)+x)*10)+2]=Tweak_Perc
Next
Next


For x=0 To gx-1
	Layout[((((0)*512)+x)*10)+1]=Layout[((((gy-2)*512)+x)*10)+1]
	Layout[((((0)*512)+x)*10)+2]=Layout[((((gy-2)*512)+x)*10)+2]
	
	Layout[((((gy-1)*512)+x)*10)+1]=Layout[((((1)*512)+x)*10)+1]
	Layout[((((gy-1)*512)+x)*10)+2]=Layout[((((1)*512)+x)*10)+2]
Next



For y=0 To gy-1
	Layout[((((y)*512)+0)*10)+1]=Layout[((((y)*512)+(gx-2))*10)+1]
	Layout[((((y)*512)+0)*10)+2]=Layout[((((y)*512)+(gx-2))*10)+2]
	
	Layout[((((y)*512)+(gx-1))*10)+1]=Layout[((((y)*512)+1)*10)+1]
	Layout[((((y)*512)+(gx-1))*10)+2]=Layout[((((y)*512)+1)*10)+2]
Next

End Function


Function SplitText$(in$,Split$,e,alsospace=0)
	;Splits text...
	Local out$=""
	Local start=1
	Local nomore=0
	Local shift
	Local size

	in$=Trim(in$)
	e=e-1
	
	For shift=1 To e
		If Instr(in$,Split$,start)+1<=nstart Then nomore=1
		If Instr(in$,Split$,start)+1>nstart Then nstart=Instr(in$,Split$,start)+1
		If AlsoSpace=1 Then If Instr(in$," ",start)+1<nstart And Instr(in$," ",start)>0 Then nstart=Instr(in$," ",start)+1
		start=nstart
	Next
	size=(Instr(in$,Split$,start))-start
	If AlsoSpace=1 Then If (Instr(in$," ",start))-start<size And Instr(in$," ",start)>0 Then size=(Instr(in$," ",start))-start
	

	out$=Mid$(in$,start,size)
	If nomore=1 Then out$="-+-"
	Return Trim$(out$)
End Function